use AdventureWorksDW
go


create procedure dbo.GetCustomerFilterOptions
as
begin
	set nocount on;

	select 
	  'Gender' as FILTER_LABEL
    , 'Gender' as FILTER_VALUE

	union all

	select 
	  'Marital Status'
    , 'Marital Status'
end
go


-- exec dbo.GetFilterChoiceList 'Gender'
create procedure dbo.GetFilterChoiceList 
  @filterby varchar(50)
as
begin
	set nocount on;

	declare @sql nvarchar(500)

	set @sql = case @filterby
	  when 'Gender' then 
	    N'select FILTER_LABEL, FILTER_VALUE 
          from dbo.GetGenderChoiceList()'
	  when 'Marital Status' then 
		N'select FILTER_LABEL, FILTER_VALUE 
          from dbo.GetMaritalStatusChoiceList()'
	end
	
	exec sp_executesql @sql
end
go


create function dbo.GetGenderChoiceList()
returns table
as
return
(
	select 
      'Female' as FILTER_LABEL
	, 'F' as FILTER_VALUE

	union all

	select 
      'Male'
	, 'M'
)


create function dbo.GetMaritalStatusChoiceList()
returns table
as
return
(
	select 
      'Married' as FILTER_LABEL
	, 'M' as FILTER_VALUE

	union all

	select 
      'Single'
	, 'S'
)


-- exec dbo.FilterCustomerList 'Gender', 'M'
create procedure dbo.FilterCustomerList
  @filterby varchar(50)	
, @filtervalue varchar(50)
as
begin
	set nocount on;
	
	select LastName, Gender, MaritalStatus
	from dbo.DimCustomer
	where 
		Gender = case when @filterby = 'Gender' then 
                   @filtervalue else Gender end
    and
	    MaritalStatus = case when @filterby = 'Marital Status' then 
                          @filtervalue else MaritalStatus end
end
go


-- test

exec dbo.GetCustomerFilterOptions

exec dbo.GetFilterChoiceList 'Gender'

exec dbo.FilterCustomerList 'Gender', 'M'
